using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Data;
using wf = System.Windows.Forms;
using System.ComponentModel;


namespace WinFormsInWPF_Data
{
  /// <summary>
  /// Interaction logic for Window1.xaml
  /// </summary>
  public partial class Window1 : System.Windows.Window
  {
    private CustomerDataSet dataSet;
    private wf.BindingSource bindingSource;
    
    public Window1()
    {
      InitializeComponent();
    }

    private void OnLoad(object sender, RoutedEventArgs e)
    {
      // 1. Erstellen des DataSet
      dataSet = new CustomerDataSet();

      // 2. Erstellen einer Windows.Forms.BindingSource
      bindingSource = new wf.BindingSource();

      bindingSource.DataSource = dataSet;
      bindingSource.DataMember = dataSet.Customers.TableName;
      
      // 3. Setzen des DataContext
      this.DataContext = bindingSource;

      // 4. Setzen der Itemssource der ListBox (DataTemplate in Xaml)
      this.listBox1.ItemsSource = bindingSource;

      // 5. DataSource fr DataGridView dgvCustomer setzen
      dgvCustomers.DataSource = bindingSource;

      // 6. DataSource fr DataGridView dgvOrders setzen
      dgvOrders.DataSource = bindingSource;
      dgvOrders.DataMember = "Customers_Orders";

      // 7. EventHandler um Windows.Forms mit WPF synchron zu halten
      ICollectionView cv = CollectionViewSource.GetDefaultView(bindingSource);
      cv.CurrentChanged += new EventHandler(cv_CurrentChanged);

      // 8. EventHandler um WPF mit Windows.Forms synchron zu halten.
      bindingSource.PositionChanged += new EventHandler(bs_PositionChanged);
    }

    private void cv_CurrentChanged(object sender, EventArgs e)
    {
      ICollectionView cv = sender as ICollectionView;
      bindingSource.Position = cv.CurrentPosition;
    }

    private void bs_PositionChanged(object sender, EventArgs e)
    {
      ICollectionView cv = CollectionViewSource.GetDefaultView(bindingSource);
      if (cv.CurrentPosition != bindingSource.Position)
        cv.MoveCurrentToPosition(bindingSource.Position);
    }

    private void btnXmlDatenLaden_Click(object sender, RoutedEventArgs e)
    {
      this.dataSet.ReadXml("CustomersOrders.xml");
      this.btnXmlDatenLaden.IsEnabled = false;
    }
  }
}