using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Forms.Integration;
using wf = System.Windows.Forms;

namespace WinFormsInWPF_PropertyMap
{
  /// <summary>
  /// Interaction logic for Window1.xaml
  /// </summary>

  public partial class Window1 : System.Windows.Window
  {
    public Window1()
    {
      InitializeComponent();
    }
    private void OnLoad(object sender, RoutedEventArgs e)
    {
      WindowsFormsHost host = new WindowsFormsHost();

      wf.TextBox txt = new wf.TextBox();
      txt.Text = "Eine simple Windows.Forms.TextBox";
      host.Child = txt;
      myWPFGrid.Children.Add(host);

      // Ersetzen des vordefinierten FlowDirection Mappings
      host.PropertyMap.Remove("FlowDirection");
      host.PropertyMap.Add("FlowDirection", new PropertyTranslator(OnFlowDirectionChange));
    }

    private void OnFlowDirectionChange(object h, string propertyName, object value)
    {
      System.Windows.FlowDirection f = (System.Windows.FlowDirection)value;

      WindowsFormsHost host = h as WindowsFormsHost;
      wf.TextBox txt = host.Child as wf.TextBox;

      txt.TextAlign = System.Windows.FlowDirection.LeftToRight == f ?
          wf.HorizontalAlignment.Left :
          wf.HorizontalAlignment.Right;
    }

    private void chkChecked(object sender, RoutedEventArgs e)
    {
      // Die Property wird auf dem WPF-Grid gesetzt, an den WindowsFormsHost bertragen und
      // von diesem mit dem Handler an die TextBox.
      myWPFGrid.FlowDirection = FlowDirection.RightToLeft;
    }
    private void chkUnchecked(object sender, RoutedEventArgs e)
    {
      myWPFGrid.FlowDirection = FlowDirection.LeftToRight;
    }
  }
}